<template>
  <div
    data-component-group="form"
    data-component="user-deny-reason"
  >
    <h2>
      {{ 'Deny reason' }}
    </h2>
    <div class="editor-box">
      <base-text-editor
        :value="denyReason"
        :config="editorConfig"
        @input="onChangeDenyReason"
      />
      <p
        v-if="hasErrors"
        class="text-error"
      >
        {{ 'The reason field is required.' }}
      </p>
    </div>

    <div class="component-actions">
      <v-btn
        class="secondary trigger cancel"
        @click="onCancel"
      >
        {{ 'Cancel' }}
      </v-btn>
      <v-btn
        class="primary trigger deny-user"
        @click="onSubmit"
      >
        <v-icon>
          thumb_down
        </v-icon>
        {{ 'Deny' }}
      </v-btn>
    </div>
  </div>
</template>

<script>
  // TODO: Translate component

  export default {
    props: {
      triggerLabel: {
        type: String,
        default: 'Update'
      }
    },
    data() {
      return {
        denyReason: '',
        editorConfig: {
          placeholder: 'Type the reason here...',
          btns: [
            ['bold', 'italic', 'underline', 'del'],
            ['unorderedList', 'orderedList'],
            ['link', 'removeformat']
          ]
        },
        hasErrors: false
      };
    },
    methods: {
      onCancel() {
        this.$emit('cancel-deny-reason');
        this.denyReason = '';
      },
      onSubmit() {
        const { denyReason } = this;

        if (denyReason === '') {
          this.hasErrors = true;
          return false;
        }

        this.$emit('deny-reason', this.denyReason);
        this.denyReason = '';
      },
      onChangeDenyReason(denyReason) {
        this.hasErrors = denyReason === '';
        this.denyReason = denyReason;
      }
    }
  };
</script>

<style lang="stylus" scoped>
  @import '../../../assets/stylus/theme.styl';

  [data-component-group="form"] {
    &[data-component="user-deny-reason"] {
      > .component-actions {
        padding: 20px 0 0 0;
        text-align: right;

        .v-btn {
          border-radius: 4px;

          .v-icon {
            margin: 0 6px 0 0;
          }
        }
      }

      .editor-box {
        position: relative;

        .text-error {
          position: absolute;
          bottom: -40px;
          left: 0;
          font-size: 12px;
          color: $colors.error;
        }
      }
    }
  }
</style>
